<?php 
class geo {
    function get_distinct_sections() {
        global $wpdb;
        
        $table_name = $wpdb->prefix . 'e_section';
        $sql = "SELECT DISTINCT section FROM " . $table_name . " ORDER BY section";
        
        $rows = $wpdb->get_results($sql);
        
        return $rows;
    }
    
    function get_pages($section) {
        global $wpdb;
        
        $table_name = $wpdb->prefix . 'e_section';
        $sql = "SELECT DISTINCT page FROM " . $table_name;
        $sql .= " WHERE section='" . $section . "' ORDER BY page";
        
        $rows = $wpdb->get_results($sql);
        return $rows;
    }
    
    function get_cities($section, $page=0) {
        global $wpdb;
        
        $table_name = $wpdb->prefix . "e_section";
        if ($page) {
            $sql = "SELECT section, page, city, count(id) as c FROM " . $table_name;
        } else {
            $sql = "SELECT section, city, count(id) as c FROM " . $table_name;           
        }
            
        $sql .= " WHERE section = '" . $section . "'";
        if ($page) {
            $sql .= " AND page = " . $page;
            $sql .= " GROUP BY section, page, city";
        } else {
            $sql .= " GROUP BY section, city";
        }
        $sql .= " ORDER BY c DESC LIMIT 10";
        
        $rows = $wpdb->get_results($sql);
        return $rows;
    }
    
    function section_view() {
        $sections = $this->get_distinct_sections();
        foreach ($sections as $section) {
            print '<div class="section">';
            print "Section: " . strtoupper($section->section) . "<br/>";
            $cities = $this->get_cities($section->section);
            print "<ul>";
            foreach ($cities as $city) {
                print "<li>";
                if ($city->city) {
                    print $city->city . ": ";
                } else {
                    print "Unknown: ";
                }
                print $city->c;
                print "</li>";
            }
            print "</ul>";
            print "<p><a href='" . E_SECTION_ADMIN . "&section=geo&e_section=" . $section->section . "'>Page Details</a></p>";
            print "</div>";
        }   
    }
    
    function page_view() {
        $pages = $this->get_pages($_GET['e_section']);
        $l = 0;
        foreach ($pages as $page) {
            $l++;
            print '<div class="section">';
            print "Page: " . strtoupper($_GET['e_section']) . $page->page . "<br/>";
            $cities = $this->get_cities($_GET['e_section'], $page->page);
            print "<ul>";
            foreach ($cities as $city) {
                print "<li>";
                if ($city->city) {
                    print $city->city . ": ";
                } else {
                    print "Unknown: ";
                }
                print $city->c;
                print "</li>";
            }
            print "</ul>";
            print "</div>";
            if (($l % 4) == 0) { print "<div class='reset'></div>"; $l = 0;}
        }
#        print "<div class='reset'></div>";
        print "<div class='reset'><a href='" . $_SERVER['HTTP_REFERER'] . "'>Return to Section Summary</a></div>";
    }
    
    function view() {
        ?>
        	<div class="wrap" id="e-section-wrap">
        	    <div id="e-section-title">
        	        <h2>E-Section - GEO Logger</h2>
        	    </div>
        	</div>
        <?php
        print '<div id="e_section_log_results">';
        if (isset($_GET['e_section'])) {
            $this->page_view();
        } else {
            $this->section_view();
        }
        print "</div>";
 
        
    }
}